/*
 * Menu.java
 *
 * Created on March 19, 2006, 2:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sshvncfileaccessablility;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.regex.*;
/**
 * the Menu that contains the options, load, and the exit function
 * @author daniel
 */
public class SSHOverVNCMenu extends JMenuBar implements ActionListener {
    /**the menu that holds an item*/
    public JMenu menu;
    /**the item to be placed in the menu*/
    public JMenuItem menuItem;
    /**the listPanel with all of the GUI Items*/
    public listPanel ListP;
    /** Creates a new instance of Menu */
    public SSHOverVNCMenu(listPanel PL) {
        ListP = PL;
        //add file menu to this menu bar
        menu = new JMenu("File");
        menu.setMnemonic(KeyEvent.VK_F);
        this.add(menu);
        
        //add load menu item to file menu
        menuItem = new JMenuItem("Load User Data");
        menuItem.setMnemonic(KeyEvent.VK_L);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        //add Exit menu item to file menu
        menuItem = new JMenuItem("Exit");
        menuItem.setMnemonic(KeyEvent.VK_X);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        //add option menu to this menubar
        menu = new JMenu("Option");
        menu.setMnemonic(KeyEvent.VK_O);
        this.add(menu);
        
        //add Change desktop Apllications Location to Option Menu
        menuItem = new JMenuItem("Change Application Location");
        menuItem.setMnemonic(KeyEvent.VK_A);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        //add Change Executable folder location to Option Menu
        menuItem = new JMenuItem("Change Executable Location");
        menuItem.setMnemonic(KeyEvent.VK_E);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        //add Change Group File Location to Option Menu
        menuItem = new JMenuItem("Change Group File");
        menuItem.setMnemonic(KeyEvent.VK_G);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        //add Change User File Location to Option Menu
        menuItem = new JMenuItem("Change User File");
        menuItem.setMnemonic(KeyEvent.VK_U);
        menuItem.addActionListener(this);
        menu.add(menuItem);
        
        
        
        
    }
    /**runs the appropriate function for the action event that occurred*/
    public void actionPerformed(ActionEvent e){
        JMenuItem source = (JMenuItem)e.getSource();
        if(source.getText().equals("Change Application Location"))
            Global.ApplicationsFileLocation = changeField("Enter your new Application File Location",Global.ApplicationsFileLocation);
        if(source.getText().equals("Change Executable Location"))
            Global.ApplicationsExecutableFolder = changeField("Enter your new Executable Folder Location",Global.ApplicationsExecutableFolder);
        if(source.getText().equals("Change Group File"))
            Global.GroupFile = changeField("Enter your new Group File Location",Global.GroupFile);
        if(source.getText().equals("Change User File"))
            Global.UserFile = changeField("Enter your new User File Location",Global.UserFile);
        if(source.getText().equals("Exit"))
            System.exit(0);
        if(source.getText().equals("Load User Data"))
            LoadUserData();
        
    }
    /**prompts user for the item the they want to enter*/
    private String changeField(String Message, String InitialValue){
        return JOptionPane.showInputDialog(
                this,
                Message,
                InitialValue);
    }
    
    /**loads the users data if the user is in the system*/
    private void LoadUserData(){
        
        if(ListP.Info.getText().equals(""))
                JOptionPane.showMessageDialog(null,
                        "You must enter a user name or group for action to perform",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
            else if(!isUserGroup(ListP.Info.getText(),ListP.Group.isSelected()))
                JOptionPane.showMessageDialog(null,
                        "You must enter a user name or group from the system to perform action",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
            else if(getAcl(ListP.Info.getText(),ListP.Group.isSelected()))
                JOptionPane.showMessageDialog(null,
                        "the List has been updated",
                        "Complete",
                        JOptionPane.INFORMATION_MESSAGE);
            else
                JOptionPane.showMessageDialog(null,
                        "error updating system be sure drive is acl compatible and that you are the super user\n" +
                        "see http://www.vanemery.com/Linux/ACL/linux-acl.html to set ACL compatibility",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
    }
    /**determines if the user/group is on the system
     *@param Name the user or Group name
     *@param isGroup true if paramater Name is a group false if its a user
     */
    private boolean isUserGroup(String Name, boolean isGroup){
        boolean isUserOrGroup=false;
        try{

            if(isGroup){
                Global.FileIn = new FileInputStream(Global.GroupFile);
                DataInputStream DataIn= new DataInputStream(Global.FileIn);
                while(DataIn.available()>0)
                {
                    if(DataIn.readLine().split(":")[0].equals(Name)){
                        isUserOrGroup=true;
                        DataIn.close();
                        Global.FileIn.close();
                        System.out.println(Name+" is in the system");
                        break;
                    }
                }
            }
            if(!isGroup){
                Global.FileIn = new FileInputStream(Global.UserFile);
                DataInputStream DataIn= new DataInputStream(Global.FileIn);
                while(DataIn.available()>0)
                {
                    if(DataIn.readLine().split(":")[0].equals(Name)){
                        isUserOrGroup=true;
                        DataIn.close();
                        Global.FileIn.close();
                        System.out.println(Name+" is in the system");
                        break;
                    }
                }
            }

        }
        catch(Exception E)
        {
            E.printStackTrace();
        }
        return isUserOrGroup;
    }
    /**compares the string
     *@param str the string to find the expression in
     *@param User the user or group to find a constraint for
     *@param isGroup true if parameter User is a group false if its a user
     */
    private boolean CompareString(String str, String User,boolean isGroup){
        Pattern pattern;
        Matcher matcher;
        pattern = Pattern.compile(
                ((isGroup)?"group":"user")+
                ":"+
                User+
                ":---");
        matcher = pattern.matcher(str);
        //System.out.println(matcher.find()+"  "+str);
        //if(matcher.find())System.out.println(str);
        return matcher.find();
    }
    /**goes through the list of programs and sets the selected box if the user has no privileges on the program
     *@param User the user name or group name
     *@param isGroup true if Paramater User is a group false if its a user
     */
    private boolean getAcl(String User,boolean isGroup){
        try{
            //go through all programs
            for(int i=0;i<ListP.PList.size();i++){
                //run getfacl against program
                Global.p = Runtime.getRuntime().exec("getfacl "+ListP.table.getValueAt(i,2));
                            
                BufferedReader stdInput = new BufferedReader(new 
                     InputStreamReader(Global.p.getInputStream()));

                BufferedReader stdError = new BufferedReader(new 
                     InputStreamReader(Global.p.getErrorStream()));

                // read the output from the command
                //check the box of the program that contains the information
                String s;
                while ((s = stdInput.readLine()) != null) {
                    if(CompareString(s,User,isGroup)){
                        ListP.table.setValueAt(true,i,3);
                        stdInput.close();
                        break;
                    }
                    else
                        ListP.table.setValueAt(false,i,3);
                }
                Global.p.waitFor();
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
            return false;
        }
        return true;
    }
    
}
