/*
 * listPanel.java
 *
 * Created on March 18, 2006, 10:31 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package sshvncfileaccessablility;
import java.awt.*;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.LayoutManager;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import java.io.*;
/**
 * Creates all the GUI Compents for this Program.
 * it also fires action listeners for the subit buttona and the 2 check boxes
 * @author daniel
 */
public class listPanel extends JPanel{
    /**used for the MyTableModel*/
    private boolean DEBUG = false;
    /**creates a local ProgramList for easy access.*/
    public ProgramList PList;
    /**a submit button to get all data and perform actions*/
    public JButton submitButton = new JButton("Update ACL's"), selectAll = new JButton("Select All"), 
            deselectAll= new JButton("Deselect All");
    /**a text field to get user, or group that will have acl previleges changed*/
    public JTextField Info = new JTextField(50);
    /**a set of check boxes to determine if the Info textfield is a user or a group.  User is the default selection*/
    public JCheckBox User= new JCheckBox("User"), Group = new JCheckBox("Group");
    /**a table to hold all the data.  This also contains a checkbox for each program and if it is selected the acl will be updated*/
    public JTable table;
    /** Creates a new instance of listPanel.  This creates the table that has the Name, comment, and executible of every program in the /usr/share/applications file.
     * This is placed into a Scroll pane for easier visiblity.  there is also a panel for the user data create containing the Info textfield, user and group check box and a lable.
     * User and Group checkboxes get the Checkbox action listener so the user can not select both user and group at the same time.
     * The last item is the submit button which gets the Buttonlistener.
     * @param PL a ProgramList that contains all of the programs that we need data for.
     */
    public listPanel(ProgramList PL) {
        PList=PL;
        setLayout (new BorderLayout());
        
        table = new JTable(new MyTableModel());
        table.setName("table");
        table.setPreferredScrollableViewportSize(new Dimension(
                java.awt.Toolkit.getDefaultToolkit().getScreenSize().width/2,
                java.awt.Toolkit.getDefaultToolkit().getScreenSize().height/2));

        //Create the scroll pane and add the table to it.
        JScrollPane scrollPane = new JScrollPane(table);
        scrollPane.setName("Scroll");
     
        //inner panel for user or group to block
        JPanel PersonInfo = new JPanel();
        PersonInfo.add(new JLabel("enter the Group or User Name:"));
        PersonInfo.add(Info);
        User.setSelected(true);
        User.addActionListener(new CheckBoxListener());
        Group.addActionListener(new CheckBoxListener());
        PersonInfo.add(User);
        PersonInfo.add(Group);
        
        //will set all the acl's approaitly
        JPanel Buttons = new JPanel();
        submitButton.addActionListener(new ButtonListener());
        selectAll.addActionListener(new SelectAllListener());
        deselectAll.addActionListener(new DeselectAllListener());
        
        Buttons.add(selectAll);
        Buttons.add(deselectAll);
        Buttons.add(submitButton);
        
        JPanel North = new JPanel();
        North.setLayout(new GridLayout(2,1));
        North.add(new SSHOverVNCMenu(this));
        North.add(PersonInfo);
        
        //Add the scroll pane to this panel.
        setLayout(new BorderLayout());
        add(North,BorderLayout.NORTH);
        add(scrollPane,BorderLayout.CENTER);
        add(Buttons,BorderLayout.SOUTH);
       // this.add(table);
    }
    
    /** when submit button is clicked check for the user or group in the /etc/group file for group and
     * the /etc/passwd for user, then once confirmed user attempt to set acl to --- for all files selected
    */
    public class ButtonListener implements ActionListener {
        /**verfies that the user or group is in the system then sets all the acls when the submit button is clicked
         * @param E the action event that was performed
         */
        public void actionPerformed(ActionEvent E){
            if(Info.getText().equals(""))
                JOptionPane.showMessageDialog(null,
                        "You must enter a user name or group for action to perform",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
            else if(!isUserGroup(Info.getText(),Group.isSelected()))
                JOptionPane.showMessageDialog(null,
                        "You must enter a user name or group from the system to perform action",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
            else if(setAcl(Info.getText(),Group.isSelected()))
                JOptionPane.showMessageDialog(null,
                        "all ACL's wer updated approaitly",
                        "Complete",
                        JOptionPane.INFORMATION_MESSAGE);
            else
                JOptionPane.showMessageDialog(null,
                        "error updating system be sure drive is acl compatible and that you are the super user\n" +
                        "see http://www.vanemery.com/Linux/ACL/linux-acl.html to set ACL compatibility",
                        "Incomplete Data",
                        JOptionPane.ERROR_MESSAGE);
        }
        /** set all the check and unchecked acls.
         * When checked the group or user specified will have its accessability rights taken away
         * When unchecked the group or user specified will have its accessability rights returned
         * @param Name a String for the user name or group name
         * @param isGroup a boolean value to determine if the Name paramater is a group or a user
         * @return a boolean value true if all acl's updated properly and false if they didn't
         */
        private boolean setAcl(String Name, boolean isGroup)
        {
            try{
                for(int i=0;i<table.getRowCount();i++){
                    
                    if(table.getValueAt(i,3).equals(true)&&isGroup)
                    {
                        System.out.println("is a Group");
                        System.out.println("setfacl -m g:"+Name+":--- "+
                                table.getValueAt(i,2).toString());
                        Process P = Runtime.getRuntime().exec("setfacl -m g:"+Name+":--- "+
                                table.getValueAt(i,2).toString());
                        P.waitFor();
                        P.destroy();
                    }
                    else if(table.getValueAt(i,3).equals(true)&&!isGroup){
                        System.out.println("is not a Group");
                        System.out.println("setfacl -m u:"+Name+":--- "+
                                table.getValueAt(i,2));
                        Process P = Runtime.getRuntime().exec("setfacl -m u:"+Name+":--- "+
                                table.getValueAt(i,2).toString());
                        P.waitFor();
                        P.destroy();
                    }
                    else if(table.getValueAt(i,3).equals(false)&&isGroup){
                        System.out.println("is a Group");
                        System.out.println("setfacl -x g:"+Name+" "+
                                table.getValueAt(i,2).toString());
                        Process P = Runtime.getRuntime().exec("setfacl -x g:"+Name+" "+
                                table.getValueAt(i,2).toString());
                        P.waitFor();
                        P.destroy();
                    }
                    
                    else if(table.getValueAt(i,3).equals(false)&&!isGroup){
                        System.out.println("is a Group");
                        System.out.println("setfacl -x u:"+Name+" "+
                                table.getValueAt(i,2).toString());
                        Process P = Runtime.getRuntime().exec("setfacl -x u:"+Name+" "+
                                table.getValueAt(i,2).toString());
                        P.waitFor();
                        P.destroy();
                    }
                }
            }
            catch(Exception E)
           {
                System.out.println();
                E.printStackTrace();
                return false;
            }
            return true;
        }
        
        /**checks the name to see if it is in the system Group or User depending of the selection of the user
         * @param Name a String for the user name or group name
         * @param isGroup a boolean value to determine if the Name paramater is a group or a user
         * @return true if the Name is found in the appropreiate file
         */
        private boolean isUserGroup(String Name, boolean isGroup){
            boolean isUserOrGroup=false;
            try{
                
                if(isGroup){
                    Global.FileIn = new FileInputStream(Global.GroupFile);
                    DataInputStream DataIn= new DataInputStream(Global.FileIn);
                    while(DataIn.available()>0)
                    {
                        if(DataIn.readLine().split(":")[0].equals(Name)){
                            isUserOrGroup=true;
                            DataIn.close();
                            Global.FileIn.close();
                            System.out.println(Name+" is in the system");
                            break;
                        }
                    }
                }
                if(!isGroup){
                    Global.FileIn = new FileInputStream(Global.UserFile);
                    DataInputStream DataIn= new DataInputStream(Global.FileIn);
                    while(DataIn.available()>0)
                    {
                        if(DataIn.readLine().split(":")[0].equals(Name)){
                            isUserOrGroup=true;
                            DataIn.close();
                            Global.FileIn.close();
                            System.out.println(Name+" is in the system");
                            break;
                        }
                    }
                }

            }
            catch(Exception E)
            {
                E.printStackTrace();
            }
            return isUserOrGroup;
        }
    }
    /**makes sure that only user checkbox or group checkbox is selected, not both*/
    public class CheckBoxListener implements ActionListener {
        /**ran if the Checkbox is clicked
         *@param E the action event that was performed
         */
        public void actionPerformed(ActionEvent E){
            if(E.getSource().equals(User)&&Group.isSelected())
                Group.setSelected(false);
            if(E.getSource().equals(Group)&&User.isSelected())
                User.setSelected(false);
        }
    }
    /**selects all the programs in the table if the Select All Button is clicked*/
    public class SelectAllListener implements ActionListener {
        /**ran if the Select All button is Clicked
         *@param E the action event that was performed
         */
        public void actionPerformed(ActionEvent E){
            for(int i=0;i<table.getRowCount();i++)
                table.setValueAt(true,i,3);
        }
    }
    /**selects all the programs in the table if the Select All Button is clicked*/
    public class DeselectAllListener implements ActionListener {
        /**ran if the Deselect All button is Clicked
         *@param E the action event that was performed
         */
        public void actionPerformed(ActionEvent E){
            for(int i=0;i<table.getRowCount();i++)
                table.setValueAt(false,i,3);
        }
    }
    /**a table model for all the data that is to be shown in the table.  This contains the Name, comment, and executible for all the programs.
     * it also checkboxes to give and take away access rights.
     */
    public class MyTableModel extends AbstractTableModel {
        /**different column headers*/
        private String[] columnNames = {"Name","Comment","Executible","Select"};
        /**all the data to be displayed in the table*/
        private Object[][] data = new Object[PList.size()][4];
       
        /**initializes the first the objects of every item in the plist of the super class*/
        public MyTableModel(){
            for(int i=0;i<PList.size();i++){
                String[] S = PList.get(i).toString().split(";");
                for(int j=0;j<S.length&&j<3;j++)
                {
                    data[i][j]=S[j];
                }
                data[i][3]=new Boolean(false);
            }
        }
        /**gets the number of columns
         * @return integer
         */
        public int getColumnCount() {
            return columnNames.length;
        }
        /**gets the number of rows
         * @return integer
         */
        public int getRowCount() {
            return data.length;
        }
        /**gets the name of the column at position col
         *@param col the index of the column that your trying to get the name for
         *@return the name of the column at col
         */
        public String getColumnName(int col) {
            return columnNames[col];
        }
        /**gets the value at the specified row and column
         * @param   row row of the data your trying to retrieve
         * @param   col column of the data your trying to retrieve
         * @return  Object at row,col of the table  
         */
        public Object getValueAt(int row, int col) {
            return data[row][col];
        }

        /*
         * JTable uses this method to determine the default renderer/
         * editor for each cell.  If we didn't implement this method,
         * then the last column would contain text ("true"/"false"),
         * rather than a check box.
         */
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }

        /*
         * Don't need to implement this method unless your table's
         * editable.
         */
        public boolean isCellEditable(int row, int col) {
            //Note that the data/cell address is constant,
            //no matter where the cell appears onscreen.
            if (col < 2) {
                return false;
            } else {
                return true;
            }
        }

        /*
         * Don't need to implement this method unless your table's
         * data can change.
         */
        public void setValueAt(Object value, int row, int col) {
            if (DEBUG) {
                System.out.println("Setting value at " + row + "," + col
                                   + " to " + value
                                   + " (an instance of "
                                   + value.getClass() + ")");
            }

            data[row][col] = value;
            fireTableCellUpdated(row, col);

            if (DEBUG) {
                System.out.println("New value of data:");
                printDebugData();
            }
        }

        private void printDebugData() {
            int numRows = getRowCount();
            int numCols = getColumnCount();

            for (int i=0; i < numRows; i++) {
                System.out.print("    row " + i + ":");
                for (int j=0; j < numCols; j++) {
                    System.out.print("  " + data[i][j]);
                }
                System.out.println();
            }
            System.out.println("--------------------------");
        }
    }
    
}
